#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "emapf.h"


int main(int argc,char ** argv) {
int k,nGeoids;
double arad,brad,eps,flatng;
const GeoidData * gdata;
  
  nGeoids = infoGeoids(&gdata);
  printf("There are %d Geoids available:\n\n",nGeoids);
  printf("Index  %15s %8s %8s %10s %10s\n",
         "Name","Arad","Brad","eccen","flatning 1./");
  for (k=0; k<nGeoids; k++) {
    switch (gdata[k].t) {
    case AB:
      arad = gdata[k].arg1;brad = gdata[k].arg2;
      eps = sqrt(1.-(brad/arad)*(brad/arad));
      break;
    case AE:
      arad = gdata[k].arg1; eps = gdata[k].arg2;
      brad = arad * sqrt(1. - eps*eps);
      break;
    case AF:
       arad = gdata[k].arg1; brad = arad * (1. - gdata[k].arg2);
       eps = sqrt(1.-(brad/arad)*(brad/arad));
       break;
    default:
      printf("Other:\n");
      arad = brad = 1.; eps = 0.;
    }
    flatng = (arad-brad)/arad;
    if (flatng > 1.e-4) {
      printf ("%5d  %15s %8.2f %8.2f %10.6f %12.8f\n",k,gdata[k].name,
        arad,brad,eps,1./flatng);
    } else {
      printf ("%5d  %15s %8.2f %8.2f %10.6f %12s\n",k,gdata[k].name,
        arad,brad,eps,"sphere");
    }
  }
  printf ("\n\nFORTRAN Users use \n\tREAL*8 PBLOCK(%d)\n"
        "for map parameter blocks.",
          (sizeof(maparam)+7)/8);
  return 0;
}
